/******************************************************************************
*                                                                             *
*    MP3.h                                  Copyright(c) 2008-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef LP_MP3_H
#define LP_MP3_H


enum MpegVersion {
	MPEG_2_5,
	MPEG_NOT,
	MPEG_2,
	MPEG_1
};

enum MpegLayer {
	MPEG_LAYER_NOT,
	MPEG_LAYER_3,
	MPEG_LAYER_2,
	MPEG_LAYER_1
};

enum MpegChannelMode {
	MPEG_CHANNEL_STEREO,
	MPEG_CHANNEL_JOINTSTEREO,
	MPEG_CHANNEL_DUALCHANNEL,
	MPEG_CHANNEL_MONO
};

struct MP3Info {
	MpegVersion Version;
	MpegLayer Layer;
	unsigned int Flags;
	MpegChannelMode ChannelMode;
	int Channels;
	int BitRate;
	int Frequency;
	int FrameSize;
	int NumFrames;
};

#define MPEG_FLAG_CRC			0x00000001
#define MPEG_FLAG_PADDING		0x00000002
#define MPEG_FLAG_PRIVATE		0x00000004
#define MPEG_FLAG_COPYRIGHTED	0x00000008
#define MPEG_FLAG_ORIGINAL		0x00000010


bool GetMP3Info(LPCTSTR pszFileName,MP3Info *pInfo);


#endif	// ndef LP_MP3_H
