/******************************************************************************
*                                                                             *
*    SeekBar.h                              Copyright(c) 2007-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef SEEKBAR_H
#define SEEKBAR_H


class SeekBar {
	HWND m_hwnd;
	int m_Min;
	int m_Max;
	int m_Pos;
	int m_KnobPos;
	int m_KnobWidth;
	COLORREF m_crBarColor;
	HBRUSH m_hbrBar;
	HBRUSH m_hbrBack;
	int m_DragStartCursorPos;
	int m_DragStartKnobPos;
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
															LPARAM lParam);
	static SeekBar *GetPointer(HWND hwnd);
	int CalcKnobPos();
	int CalcPos(int KnobPos);
	int GetKnobPos(int x);
	void SendPosChangeNotify(int Type);
public:
	static bool Init(HINSTANCE hinst);
	SeekBar(HWND hwndParent,int ID,unsigned int Style,
						int Left,int Top,int Width,int Height,HINSTANCE hinst);
	~SeekBar();
	HWND GetHandle() { return m_hwnd; }
	void SetRange(int Min,int Max);
	int GetPos() { return m_Pos; }
	void SetPos(int Pos);
	void SetBarColor(COLORREF crColor);
	enum {
		TRACK_THUMB=1,
		TRACK_END
	};
};


#endif	// ndef SEEKBAR_H
