/******************************************************************************
*                                                                             *
*    Settings.h                             Copyright(c) 2005-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef SETTINGS_H
#define SETTINGS_H


class Settings {
	TCHAR m_szFileName[MAX_PATH];
	TCHAR m_szSection[64];
	unsigned int m_OpenFlags;
public:
	enum {
		OPEN_READ  = 0x00000001,
		OPEN_WRITE = 0x00000002
	};
	Settings();
	~Settings();
	bool Open(LPCTSTR pszFileName,LPCTSTR pszSection,unsigned int Flags);
	void Close();
	bool Clear();
	bool ReadInt(LPCTSTR pszValueName,int *pData);
	bool WriteInt(LPCTSTR pszValueName,int Data);
	bool ReadUInt(LPCTSTR pszValueName,unsigned int *pData);
	bool WriteUInt(LPCTSTR pszValueName,unsigned int Data);
	bool ReadIntArray(LPCTSTR pszValueName,int *pData,int *pLength);
	bool WriteIntArray(LPCTSTR pszValueName,const int *pData,int Length);
	bool ReadString(LPCTSTR pszValueName,LPTSTR pszData,unsigned int Max);
	bool WriteString(LPCTSTR pszValueName,LPCTSTR pszData);
	bool ReadBoolean(LPCTSTR pszValueName,bool *pfData);
	bool ReadBoolean(LPCTSTR pszValueName,BOOL *pfData);
	bool WriteBoolean(LPCTSTR pszValueName,bool fData);
	bool ReadColor(LPCTSTR pszValueName,COLORREF *pcrData);
	bool WriteColor(LPCTSTR pszValueName,COLORREF crData);
};


#endif	// ndef SETTINGS_H
