/******************************************************************************
*                                                                             *
*    Theme.h                                Copyright(c) 2007-2009 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef THEME_H
#define THEME_H


#include "LPTheme.h"


struct ThemePluginInfo {
	UINT Flags;
	TCHAR Name[LP_THEME_MAX_NAME];
	TCHAR Copyright[LP_THEME_MAX_COPYRIGHT];
	TCHAR Description[LP_THEME_MAX_DESCRIPTION];
};

class ThemePlugin {
	HINSTANCE m_hLib;
	TCHAR m_FileName[MAX_PATH];
	LPThemeInfo m_Info;
public:
	ThemePlugin();
	~ThemePlugin();
	bool Load(LPCTSTR pFileName);
	LPCTSTR FileName() const { return m_FileName; }
	void GetInfo(ThemePluginInfo *pInfo) const;
	bool GetToolbarInfo(LPThemeToolbarInfo *pInfo) const;
	HBITMAP LoadBitmap(int Type) const;
	enum ButtonStat {
		BUTTON_STAT_NORMAL,
		BUTTON_STAT_HOT,
		BUTTON_STAT_DISABLED
	};
	HIMAGELIST LoadImageList(int Type,ButtonStat Stat) const;
};

class ThemePluginList {
	int m_NumPlugins;
	class ThemePlugin *m_pList;
public:
	ThemePluginList();
	~ThemePluginList();
	int NumPlugins() const { return m_NumPlugins; }
	bool LoadPlugins(LPCTSTR pDirectory);
	const ThemePlugin *GetPlugin(int No) { return &m_pList[No]; }
};


#endif	// ndef THEME_H
